Index: unk/src/os2ahci.map
===================================================================
--- /trunk/src/os2ahci.map	(revision 9)
+++ 	(revision )
@@ -1,471 +1,0 @@
-Open Watcom Linker Version 1.9
-Portions Copyright (c) 1985-2002 Sybase, Inc. All Rights Reserved.
-Created on:       10/09/13 00:39:21
-Warning! W1008: cannot open SLIBCE.lib : No such file or directory
-Warning! W1162: file slibcep.lib(cmiscdat.asm), record 10: relocations on iterated data not supported
-Executable Image: os2ahci.add
-creating an OS/2 16-bit dynamic link library
-Error! E2028: _c_strat is an undefined reference
-Error! E2028: _restart_ctxhook is an undefined reference
-Error! E2028: _reset_ctxhook is an undefined reference
-Error! E2028: _engine_ctxhook is an undefined reference
-Error! E2028: DEVHELP_SAVE_MESSAGE is an undefined reference
-Error! E2028: __I4M is an undefined reference
-Error! E2028: ADD_STARTTIMERMS is an undefined reference
-Error! E2028: ADD_CANCELTIMER is an undefined reference
-Error! E2028: __U4M is an undefined reference
-Error! E2028: __U4D is an undefined reference
-Error! E2028: DEVHELP_GETDOSVAR is an undefined reference
-Error! E2028: DEVHELP_YIELD is an undefined reference
-Error! E2028: DEVHELP_INTERNALERROR is an undefined reference
-Error! E2028: ADD_INITTIMER is an undefined reference
-Error! E2028: DEVHELP_REGISTERDEVICECLASS is an undefined reference
-Error! E2028: restart_hook_ is an undefined reference
-Error! E2028: DEVHELP_ALLOCATECTXHOOK is an undefined reference
-Error! E2028: reset_hook_ is an undefined reference
-Error! E2028: engine_hook_ is an undefined reference
-Error! E2028: end_of_code_ is an undefined reference
-Error! E2028: DEVHELP_FREECTXHOOK is an undefined reference
-Error! E2028: memset_ is an undefined reference
-Error! E2028: DEVHELP_ARMCTXHOOK is an undefined reference
-Error! E2028: memcpy_ is an undefined reference
-Error! E2028: DEVHELP_ALLOCPHYS is an undefined reference
-Error! E2028: DEVHELP_ALLOCGDTSELECTOR is an undefined reference
-Error! E2028: DEVHELP_PHYSTOGDTSELECTOR is an undefined reference
-Error! E2028: DEVHELP_FREEPHYS is an undefined reference
-Error! E2028: DEVHELP_FREEGDTSELECTOR is an undefined reference
-Error! E2028: DEVHELP_ATTACHDD is an undefined reference
-Error! E2028: readl_ is an undefined reference
-Error! E2028: writel_ is an undefined reference
-Error! E2028: DEVHELP_SETIRQ is an undefined reference
-Error! E2028: DEVHELP_EOI is an undefined reference
-Error! E2028: DEVHELP_VIRTTOPHYS is an undefined reference
-Error! E2028: _main is an undefined reference
-
-
-                        +------------+
-                        |   Groups   |
-                        +------------+
-
-Group                           Address              Size
-=====                           =======              ====
-
-TGROUP                          0001:0000            00006a9a
-DGROUP                          0004:0000            0000caa0
-
-
-
-                        +--------------+
-                        |   Segments   |
-                        +--------------+
-
-Segment                Class          Group          Address         Size
-=======                =====          =====          =======         ====
-
-_TEXT                  CODE           TGROUP         0001:0000       00006a99
-CODE                   CODE           TGROUP         0001:6a9a       00000000
-_z_text                CODE           TGROUP         0001:6a9a       00000000
-RMCode                 CODE           AUTO           0002:0000       000001d8
-LIBCODE                CODE           AUTO           0002:01d8       00000000
-EMULATOR_TEXT          CODE           AUTO           0003:0000       00000002
-C_ETEXT                ENDCODE        AUTO           0003:0002       00000000
-EMULATOR_DATA          FAR_DATA       AUTO           0004:0000       00000000
-NULL                   BEGDATA        DGROUP         0004:0000       00000042
-_DATA                  DATA           DGROUP         0004:0042       00000e76
-DEVHDR                 DATA           DGROUP         0004:0eb8       00000020
-CONST                  DATA           DGROUP         0004:0ed8       00001277
-CONST2                 DATA           DGROUP         0004:2150       00000000
-CDATA                  DATA           DGROUP         0004:2150       0000000e
-XIFB                   DATA           DGROUP         0004:215e       00000000
-XIF                    DATA           DGROUP         0004:215e       00000000
-XIFE                   DATA           DGROUP         0004:215e       00000000
-XIB                    DATA           DGROUP         0004:215e       00000000
-XI                     DATA           DGROUP         0004:215e       00000000
-XIE                    DATA           DGROUP         0004:215e       00000000
-XPB                    DATA           DGROUP         0004:215e       00000000
-XP                     DATA           DGROUP         0004:215e       00000002
-XPE                    DATA           DGROUP         0004:2160       00000000
-XCB                    DATA           DGROUP         0004:2160       00000000
-XC                     DATA           DGROUP         0004:2160       00000000
-XCE                    DATA           DGROUP         0004:2160       00000000
-XCFB                   DATA           DGROUP         0004:2160       00000000
-XCF                    DATA           DGROUP         0004:2160       00000000
-XCFE                   DATA           DGROUP         0004:2160       00000000
-HDR                    MSG            DGROUP         0004:2160       00000008
-MSG                    MSG            DGROUP         0004:2168       00000102
-PAD                    MSG            DGROUP         0004:226a       00000002
-EPAD                   MSG            DGROUP         0004:226c       00000001
-CONST                  CONST          DGROUP         0004:226e       00000000
-_BSS                   BSS            DGROUP         0004:226e       0000a620
-c_common               BSS            DGROUP         0004:c890       00000200
-_z_data                BSS            DGROUP         0004:ca90       00000001
-XOB                    BSS            DGROUP         0004:ca92       00000000
-XO                     BSS            DGROUP         0004:ca92       00000000
-XOE                    BSS            DGROUP         0004:ca92       00000000
-STACK                  STACK          DGROUP         0004:caa0       00000000
-
-
-                        +----------------+
-                        |   Memory Map   |
-                        +----------------+
-
-* = unreferenced symbol
-+ = symbol only referenced locally
-
-Address        Symbol
-=======        ======
-
-Module: init.obj(C:\prj\ahci\trunk\src\init.asm)
-0001:0000*     _asm_strat
-0001:000d*     _readl
-0001:0046*     _writel
-0001:0086*     _memset
-0001:00c2*     _memcpy
-0001:0100*     _restart_hook
-0001:010c*     _reset_hook
-0001:0118*     _engine_hook
-0004:0eb8*     _dev_hdr
-0004:ca90      _end_of_data
-0001:6a9a*     _end_of_code
-Module: libc.obj(C:\prj\ahci\trunk\src\libc.c)
-0001:0124      init_com1_
-0001:016f+     vsprintf_
-0001:03bb      sprintf_
-0001:03d5+     vprintf_
-0001:044b      printf_
-0001:045f      cprintf_
-0001:04c0      phex_
-0001:058f+     strlen_
-0001:05a8+     strcpy_
-0001:05d4      memcmp_
-0001:060e      strtol_
-0001:06dd      malloc_
-0001:0772      free_
-0001:07bf      mdelay_cal_
-0001:0833      mdelay_
-0001:091a      msleep_
-0001:09c6      panic_
-0001:09d9      disable_
-0001:09f9      enable_
-0004:00d8+     _mdelay_cal_status
-0004:00d9+     _mdelay_loops_per_ms
-Module: os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-0004:00de      _debug
-0004:00e0      _Device_Help
-0004:00e4      _RMFlags
-0004:00e8      _RM_Help0
-0004:00ec      _RM_Help3
-0004:00f0+     _rm_drvinfo
-0001:0adc*     c_strat_
-0001:0af5+     init_drv_
-0001:0e18+     add_entry_
-0001:0f9a      trigger_engine_
-0001:0fc5      trigger_engine_1_
-0001:1068+     send_iorb_
-0001:110d+     iocc_configuration_
-0001:11b2+     iocc_device_control_
-0001:12d8+     iocc_unit_control_
-0001:13c0+     iocm_device_table_
-0001:1692+     iocc_geometry_
-0001:16c8+     iocc_execute_io_
-0001:1715+     iocc_unit_status_
-0001:1734+     iocc_adapter_passthru_
-0001:175e      iorb_queue_add_
-0001:17ef      iorb_queue_del_
-0001:1907      iorb_seterr_
-0001:1918      iorb_done_
-0001:19e9      iorb_requeue_
-0004:4ab2*     _rm_drvname
-0004:4b02      _link_speed
-0004:4d02+     _driver_queue
-0004:4d0a      _ad_infos
-0004:bdca      _drv_lock
-0004:bdce      _rm_drvh
-0004:bdd2+     _timer_pool
-0004:c7e8      _init_complete
-0004:c7ea      _thorough_scan
-0004:c7ec+     _add_handle
-0004:c7ee      _ad_info_cnt
-0004:c7f0      _init_reset
-Module: pci.obj(C:\prj\ahci\trunk\src\pci.c)
-0001:1a64      add_pci_id_
-0001:1aa2      scan_pci_bus_
-0001:1ba6      pci_enable_int_
-0001:1bfa      pci_hack_virtualbox_
-0004:014c+     _pci_ids
-Module: ahci.obj(C:\prj\ahci\trunk\src\ahci.c)
-0001:24ca+     ahci_save_bios_config_
-0001:289b+     ahci_restore_bios_config_
-0001:290a*     ahci_restore_initial_config_
-0001:297b+     ahci_save_port_config_
-0001:29e4+     ahci_restore_port_config_
-0001:2a73+     ahci_enable_ahci_
-0001:2afe      ahci_scan_ports_
-0001:2cfe      ahci_complete_init_
-0001:2e3f      ahci_reset_port_
-0001:30c7      ahci_start_port_
-0001:314c+     ahci_start_fis_rx_
-0001:31e3+     ahci_start_engine_
-0001:3219      ahci_stop_port_
-0001:3292+     ahci_stop_fis_rx_
-0001:32f8+     ahci_stop_engine_
-0001:335b+     ahci_exec_iorb_
-0001:36c6+     ahci_exec_polled_iorb_
-0001:3907+     ahci_exec_polled_cmd_
-0001:3a08+     ahci_intr_
-0001:3af3+     ahci_port_intr_
-0001:3da4+     ahci_error_intr_
-0001:3eb2      ahci_get_geometry_
-0001:3f30      ahci_unit_ready_
-0001:3fab      ahci_read_
-0001:403d      ahci_verify_
-0001:40c8      ahci_write_
-0001:4153      ahci_execute_cdb_
-0001:41d6      ahci_execute_ata_
-0004:0c28+     _initial_flags
-0004:0c3c+     _irq_handlers
-Module: ata.obj(C:\prj\ahci\trunk\src\ata.c)
-0001:459e+     ata_cmd_
-0001:45d6      v_ata_cmd_
-0001:49a2+     ata_cmd_to_fis_
-0001:4a7a+     ata_get_sg_indx_
-0001:4ac5+     ata_max_sg_cnt_
-0001:4b5d      ata_get_geometry_
-0001:4bea+     ata_get_geometry_pp_
-0001:4cdb      ata_unit_ready_
-0001:4ce9      ata_read_
-0001:4e81+     ata_read_pp_
-0001:4ec6      ata_verify_
-0001:4f9c      ata_write_
-0001:5123+     ata_write_pp_
-0001:514a      ata_execute_ata_
-0001:5153      ata_req_sense_
-0001:51c8      ata_dev_name_
-Module: atapi.obj(C:\prj\ahci\trunk\src\atapi.c)
-0001:51f5      atapi_req_sense_
-0001:51f5      atapi_execute_cdb_
-0001:51f5      atapi_write_
-0001:51f5      atapi_verify_
-0001:51f5      atapi_read_
-0001:51f5      atapi_unit_ready_
-0001:51f5      atapi_get_geometry_
-Module: ctxhook.obj(C:\prj\ahci\trunk\src\ctxhook.c)
-0001:51ff*     restart_ctxhook_
-0001:560b*     reset_ctxhook_
-0001:597e*     engine_ctxhook_
-0004:c83a      _ports_to_restart
-0004:c85a      _abort_queue
-0004:c862      _ports_to_reset
-0004:c882      _engine_ctxhook_h
-0004:c886      _reset_ctxhook_h
-0004:c88a      _restart_ctxhook_h
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(printf.c)
-0001:5a02      _printf
-Module: c:\devel\ddk\BASE\LIB\rmcalls.lib(rmcdrvr.c)
-0002:0000+     MY_DEVHELP_ATTACHDD
-0002:0022      _RMCreateDriver
-Module: c:\devel\ddk\BASE\LIB\rmcalls.lib(rmddrvr.c)
-0002:009c      _RMDestroyDriver
-Module: c:\devel\ddk\BASE\LIB\rmcalls.lib(rmares.c)
-0002:00c8      _RMAllocResource
-Module: c:\devel\ddk\BASE\LIB\rmcalls.lib(rmcadpt.c)
-0002:0102      _RMCreateAdapter
-Module: c:\devel\ddk\BASE\LIB\rmcalls.lib(rmdres.c)
-0002:013c      _RMDeallocResource
-Module: c:\devel\ddk\BASE\LIB\rmcalls.lib(rmcdev.c)
-0002:0168      _RMCreateDevice
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(output.asm)
-0001:5a4e      __output
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(_file.c)
-0004:c890+     __bufin
-0004:0d68      __iob2
-0004:0e08      __lastiob
-0004:0cc8      __iob
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(_sftbuf.asm)
-0001:5f8c      __ftbuf
-0001:5f24      __stbuf
-Module: c:\devel\ddk\BASE\LIB\rmcalls.lib(rmcall.c)
-0002:01a2      _CallRM
-0002:01ca+     _GetCS
-Module: c:\devel\ddk\BASE\LIB\rmcalls.lib(rmdata.c)
-0004:0e0e      _RMIDCTable
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(cmiscdat.asm)
-0004:0e1a      __cfltcvt_tab
-0004:0e2a*     __asizeC
-0004:0e2b*     __asizeD
-0004:0e28*     __sigintoff
-0004:0e26*     __sigintseg
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(_flsbuf.asm)
-0001:5fca      __flsbuf
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(chkstk.asm)
-0004:0e2e      STKHQQ
-0004:0e2c*     __aaltstkovr
-0001:60a4      __chkstk
-0001:60a4*     __aNchkstk
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(malloc.asm)
-0001:60bc      _malloc
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(fflush.c)
-0001:60c0      _fflush
-0001:6132      _flushall
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(os2\crt0dat.asm)
-0004:0e3e*     __osversion
-0004:0e3a      _errno
-0001:621c      __exit
-0004:0e77*     __child
-0004:0e43      __nfile
-0001:6184      __cinit
-0004:0e6d      ___argc
-0001:6224*     __cexit
-0004:0e3e*     __dosvermajor
-0004:0e41*     __oserr
-0004:0e6f      ___argv
-0004:0e3f*     __dosverminor
-0004:0e59*     __pipech
-0004:0e71      _environ
-0004:0e45      __osfile
-0004:0e40      __osmode
-0004:2152*     __fpinit
-0004:0e73      __pgmptr
-0001:622e*     __c_exit
-0004:0e40*     __dosmode
-0004:0e3e      __osmajor
-0004:0e3f*     __osminor
-0004:0e3c*     __umaskval
-0001:6290*     __ctermsub
-0004:0e41      __doserrno
-0003:0000*     __EmDataSeg
-0004:0e30*     __fac
-0001:6215      _exit
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(_cflush.asm)
-0004:0e7a      __cflush
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(crt0fp.asm)
-0001:62c0      __fptrap
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(os2\lseek.asm)
-0001:62c6      _lseek
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(write.asm)
-0001:6304      _write
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(_getbuf.asm)
-0001:648c      __getbuf
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(os2\crt0.asm)
-0004:0e82*     __aexit_rtn
-0004:0e86      __nheap_desc
-0004:0eac*     ___aDBswpflg
-0004:0e7c      __acmdln
-0004:0eaa*     __aseghi
-0004:0ea8*     __aseglo
-0004:0e84*     __asizds
-0001:64ce*     __astart
-0004:0e80*     __atopsp
-0004:0e9a      __acfinfo
-0000:d6d6*     __aDBused
-0001:659a*     __dataseg
-0004:0e7e      __aenvseg
-0001:6533      __cintDIV
-0000:d6d6*     __aDBdoswp
-0000:9876*     __acrtused
-0004:0eae*     ___aDBrterr
-0001:653d      __amsg_exit
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(nmalloc.asm)
-0001:659c*     __nfree
-0001:65bd      __nmalloc
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(chksum.asm)
-0001:65e6      __nullcheck
-0004:0042*     __anullsize
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(os2\dosret.asm)
-0001:6663      __dosret
-0001:6654      __dosretf
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(stackava.asm)
-0001:66a0      _stackavail
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(os2\nmsghdr.asm)
-0001:66b2*     __NMSG_TEXT
-0001:66e2      __NMSG_WRITE
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(os2\crt0msg.asm)
-0001:6716      __FF_MSGBANNER
-0004:0eb0*     __adbgmsg
-0000:9876      __acrtmsg
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(os2\stdargv.asm)
-0001:6736      __setargv
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(os2\stdenvp.asm)
-0001:68a4      __setenvp
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(growseg.asm)
-0001:69ab*     __incseg
-0001:691c      __growseg
-0001:69de*     __findlast
-0004:0eb6      __amblksiz
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(searchsg.asm)
-0001:69fe      __searchseg
-Module: c:\devel\ddk\BASE\LIB\slibcep.lib(os2\stdalloc.asm)
-0001:6a7a      __stdalloc
-
-
-                        +---------------------------+
-                        |   Unresolved References   |
-                        +---------------------------+
-
-Undefined Symbol                Referenced by
-================                =============
-
-_c_strat                        init.obj(C:\prj\ahci\trunk\src\init.asm)
-_restart_ctxhook                init.obj(C:\prj\ahci\trunk\src\init.asm)
-_reset_ctxhook                  init.obj(C:\prj\ahci\trunk\src\init.asm)
-_engine_ctxhook                 init.obj(C:\prj\ahci\trunk\src\init.asm)
-DEVHELP_SAVE_MESSAGE            libc.obj(C:\prj\ahci\trunk\src\libc.c)
-__I4M                           libc.obj(C:\prj\ahci\trunk\src\libc.c)
-ADD_STARTTIMERMS                libc.obj(C:\prj\ahci\trunk\src\libc.c)
-ADD_CANCELTIMER                 libc.obj(C:\prj\ahci\trunk\src\libc.c)
-__U4M                           libc.obj(C:\prj\ahci\trunk\src\libc.c)
-__U4D                           libc.obj(C:\prj\ahci\trunk\src\libc.c)
-DEVHELP_GETDOSVAR               libc.obj(C:\prj\ahci\trunk\src\libc.c)
-DEVHELP_YIELD                   libc.obj(C:\prj\ahci\trunk\src\libc.c)
-DEVHELP_INTERNALERROR           libc.obj(C:\prj\ahci\trunk\src\libc.c)
-ADD_INITTIMER                   os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-DEVHELP_REGISTERDEVICECLASS     os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-restart_hook_                   os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-DEVHELP_ALLOCATECTXHOOK         os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-reset_hook_                     os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-engine_hook_                    os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-end_of_code_                    os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-DEVHELP_FREECTXHOOK             os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-memset_                         os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-DEVHELP_ARMCTXHOOK              os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-memcpy_                         os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-ADD_CANCELTIMER                 os2ahci.obj(C:\prj\ahci\trunk\src\os2ahci.c)
-memset_                         pci.obj(C:\prj\ahci\trunk\src\pci.c)
-DEVHELP_ALLOCPHYS               pci.obj(C:\prj\ahci\trunk\src\pci.c)
-DEVHELP_ALLOCGDTSELECTOR        pci.obj(C:\prj\ahci\trunk\src\pci.c)
-DEVHELP_PHYSTOGDTSELECTOR       pci.obj(C:\prj\ahci\trunk\src\pci.c)
-__U4M                           pci.obj(C:\prj\ahci\trunk\src\pci.c)
-DEVHELP_FREEPHYS                pci.obj(C:\prj\ahci\trunk\src\pci.c)
-DEVHELP_FREEGDTSELECTOR         pci.obj(C:\prj\ahci\trunk\src\pci.c)
-DEVHELP_ATTACHDD                pci.obj(C:\prj\ahci\trunk\src\pci.c)
-readl_                          ahci.obj(C:\prj\ahci\trunk\src\ahci.c)
-writel_                         ahci.obj(C:\prj\ahci\trunk\src\ahci.c)
-DEVHELP_SETIRQ                  ahci.obj(C:\prj\ahci\trunk\src\ahci.c)
-__U4M                           ahci.obj(C:\prj\ahci\trunk\src\ahci.c)
-ADD_STARTTIMERMS                ahci.obj(C:\prj\ahci\trunk\src\ahci.c)
-__U4D                           ahci.obj(C:\prj\ahci\trunk\src\ahci.c)
-ADD_CANCELTIMER                 ahci.obj(C:\prj\ahci\trunk\src\ahci.c)
-DEVHELP_EOI                     ahci.obj(C:\prj\ahci\trunk\src\ahci.c)
-memset_                         ahci.obj(C:\prj\ahci\trunk\src\ahci.c)
-DEVHELP_ARMCTXHOOK              ahci.obj(C:\prj\ahci\trunk\src\ahci.c)
-memset_                         ata.obj(C:\prj\ahci\trunk\src\ata.c)
-__U4M                           ata.obj(C:\prj\ahci\trunk\src\ata.c)
-memcpy_                         ata.obj(C:\prj\ahci\trunk\src\ata.c)
-DEVHELP_VIRTTOPHYS              ata.obj(C:\prj\ahci\trunk\src\ata.c)
-__U4D                           ata.obj(C:\prj\ahci\trunk\src\ata.c)
-readl_                          ata.obj(C:\prj\ahci\trunk\src\ata.c)
-memset_                         ctxhook.obj(C:\prj\ahci\trunk\src\ctxhook.c)
-readl_                          ctxhook.obj(C:\prj\ahci\trunk\src\ctxhook.c)
-writel_                         ctxhook.obj(C:\prj\ahci\trunk\src\ctxhook.c)
-DEVHELP_ARMCTXHOOK              ctxhook.obj(C:\prj\ahci\trunk\src\ctxhook.c)
-ADD_CANCELTIMER                 ctxhook.obj(C:\prj\ahci\trunk\src\ctxhook.c)
-_main                           slibcep.lib(os2\crt0.asm)
-
-
-                        +--------------------+
-                        |   Libraries Used   |
-                        +--------------------+
-
-C:\WATCOM/lib286/os2\os2.lib
-c:\devel\ddk\BASE\LIB\slibcep.lib
-c:\devel\ddk\BASE\LIB\rmcalls.lib