Index: /branches/1.0/src/de/uni.dlg
===================================================================
--- /branches/1.0/src/de/uni.dlg	(revision 10)
+++ /branches/1.0/src/de/uni.dlg	(revision 11)
@@ -2,9 +2,9 @@
    #include <os2.h>
 #endif
-DLGINCLUDE 1 "UNI.h"
+DLGINCLUDE 1 "U:\Develop\unipdr\src\de\UNI.h"
 
 DLGTEMPLATE IDD_UNI LOADONCALL MOVEABLE DISCARDABLE
 BEGIN
-    DIALOG  "Port Properties - ", IDD_UNI, 15, 37, 232, 156, FS_NOBYTEALIGN | 
+    DIALOG  "Port Properties - ", IDD_UNI, 19, 37, 233, 156, FS_NOBYTEALIGN | 
             WS_VISIBLE | WS_SYNCPAINT, FCF_SYSMENU | FCF_TITLEBAR | 
             FCF_NOBYTEALIGN
@@ -16,32 +16,30 @@
                         PRESPARAMS PP_FONTNAMESIZE, "9.WarpSans Bold"
         GROUPBOX        "Universal port driver properties", GB_UNICFG, 5, 96, 
-                        220, 54
+                        220, 54,
                         PRESPARAMS PP_FOREGROUNDCOLOR, 0x00000000L
                         PRESPARAMS PP_FONTNAMESIZE, "9.WarpSans Bold"
-        GROUPBOX        "Login as", 1024, 5, 53, 220, 40
+        GROUPBOX        "Login as", 1024, 5, 53, 220, 40, NOT WS_VISIBLE
                         PRESPARAMS PP_FOREGROUNDCOLOR, 0x00000000L
                         PRESPARAMS PP_FONTNAMESIZE, "9.WarpSans Bold"
-        LTEXT           "Workgroup:", DT_WORKGROUP, 13, 130, 53, 8, 
+        LTEXT           "Program:", DT_PROGRAM, 13, 130, 53, 8, DT_VCENTER
+        ENTRYFIELD      "", ID_PROGRAM, 71, 131, 142, 8, ES_MARGIN
+        LTEXT           "Parameters:", DT_PARAMETERS, 13, 116, 53, 8, 
                         DT_VCENTER
-        ENTRYFIELD      "", ID_WORKGROUP, 71, 131, 142, 8, ES_MARGIN
-        LTEXT           "Server:", DT_IP, 13, 116, 53, 8, DT_VCENTER
-        ENTRYFIELD      "", ID_IP, 71, 117, 142, 8, ES_MARGIN
-        LTEXT           "Printer:", DT_UNIQUEUE, 13, 102, 53, 8, DT_VCENTER
-        ENTRYFIELD      "", ID_UNIQUEUE, 71, 103, 142, 8, ES_MARGIN
+        LTEXT           "Printer:", DT_UNIQUEUE, 13, 102, 53, 8, DT_VCENTER | 
+                        NOT WS_VISIBLE
+        ENTRYFIELD      "", ID_UNIQUEUE, 71, 103, 142, 8, ES_MARGIN | NOT 
+                        WS_VISIBLE
         AUTOCHECKBOX    "Send as binary file", ID_BINARY, 115, 148, 75, 8, 
                         NOT WS_VISIBLE | WS_DISABLED
-        LTEXT           "User ID:", DT_USER, 13, 73, 53, 8, DT_VCENTER
-        ENTRYFIELD      "", ID_USER, 71, 74, 110, 8, ES_MARGIN
-        LTEXT           "Password:", DT_PASSWORD, 13, 59, 53, 10, DT_VCENTER
-        ENTRYFIELD      "", ID_PASSWORD, 71, 60, 110, 8, ES_MARGIN | 
-                        ES_UNREADABLE
-        GROUPBOX        "Number of copies", GB_COPIES, 5, 24, 220, 26
+        GROUPBOX        "Number of copies", GB_COPIES, 5, 24, 220, 26, NOT 
+                        WS_VISIBLE
                         PRESPARAMS PP_FOREGROUNDCOLOR, 0x00000000L
                         PRESPARAMS PP_FONTNAMESIZE, "9.WarpSans Bold"
         LTEXT           "Spool this job", DT_COPIES, 13, 30, 54, 8, 
-                        DT_VCENTER
+                        DT_VCENTER | NOT WS_VISIBLE
         LTEXT           "times to the server", DT_COPIES2, 104, 30, 83, 8, 
-                        DT_VCENTER
-        ENTRYFIELD      "", ID_COPIES, 71, 31, 23, 8, ES_MARGIN
+                        DT_VCENTER | NOT WS_VISIBLE
+        ENTRYFIELD      "", ID_COPIES, 71, 31, 23, 8, ES_MARGIN | NOT 
+                        WS_VISIBLE
     END
 END
Index: /branches/1.0/src/en/uni.dlg
===================================================================
--- /branches/1.0/src/en/uni.dlg	(revision 10)
+++ /branches/1.0/src/en/uni.dlg	(revision 11)
@@ -2,9 +2,9 @@
    #include <os2.h>
 #endif
-DLGINCLUDE 1 "UNI.h"
+DLGINCLUDE 1 "U:\Develop\unipdr\src\de\UNI.h"
 
 DLGTEMPLATE IDD_UNI LOADONCALL MOVEABLE DISCARDABLE
 BEGIN
-    DIALOG  "Port Properties - ", IDD_UNI, 15, 37, 232, 156, FS_NOBYTEALIGN | 
+    DIALOG  "Port Properties - ", IDD_UNI, 19, 37, 233, 156, FS_NOBYTEALIGN | 
             WS_VISIBLE | WS_SYNCPAINT, FCF_SYSMENU | FCF_TITLEBAR | 
             FCF_NOBYTEALIGN
@@ -16,32 +16,30 @@
                         PRESPARAMS PP_FONTNAMESIZE, "9.WarpSans Bold"
         GROUPBOX        "Universal port driver properties", GB_UNICFG, 5, 96, 
-                        220, 54
+                        220, 54,
                         PRESPARAMS PP_FOREGROUNDCOLOR, 0x00000000L
                         PRESPARAMS PP_FONTNAMESIZE, "9.WarpSans Bold"
-        GROUPBOX        "Login as", 1024, 5, 53, 220, 40
+        GROUPBOX        "Login as", 1024, 5, 53, 220, 40, NOT WS_VISIBLE
                         PRESPARAMS PP_FOREGROUNDCOLOR, 0x00000000L
                         PRESPARAMS PP_FONTNAMESIZE, "9.WarpSans Bold"
-        LTEXT           "Workgroup:", DT_WORKGROUP, 13, 130, 53, 8, 
+        LTEXT           "Program:", DT_PROGRAM, 13, 130, 53, 8, DT_VCENTER
+        ENTRYFIELD      "", ID_PROGRAM, 71, 131, 142, 8, ES_MARGIN
+        LTEXT           "Parameters:", DT_PARAMETERS, 13, 116, 53, 8, 
                         DT_VCENTER
-        ENTRYFIELD      "", ID_WORKGROUP, 71, 131, 142, 8, ES_MARGIN
-        LTEXT           "Server:", DT_IP, 13, 116, 53, 8, DT_VCENTER
-        ENTRYFIELD      "", ID_IP, 71, 117, 142, 8, ES_MARGIN
-        LTEXT           "Printer:", DT_UNIQUEUE, 13, 102, 53, 8, DT_VCENTER
-        ENTRYFIELD      "", ID_UNIQUEUE, 71, 103, 142, 8, ES_MARGIN
+        LTEXT           "Printer:", DT_UNIQUEUE, 13, 102, 53, 8, DT_VCENTER | 
+                        NOT WS_VISIBLE
+        ENTRYFIELD      "", ID_UNIQUEUE, 71, 103, 142, 8, ES_MARGIN | NOT 
+                        WS_VISIBLE
         AUTOCHECKBOX    "Send as binary file", ID_BINARY, 115, 148, 75, 8, 
                         NOT WS_VISIBLE | WS_DISABLED
-        LTEXT           "User ID:", DT_USER, 13, 73, 53, 8, DT_VCENTER
-        ENTRYFIELD      "", ID_USER, 71, 74, 110, 8, ES_MARGIN
-        LTEXT           "Password:", DT_PASSWORD, 13, 59, 53, 10, DT_VCENTER
-        ENTRYFIELD      "", ID_PASSWORD, 71, 60, 110, 8, ES_MARGIN | 
-                        ES_UNREADABLE
-        GROUPBOX        "Number of copies", GB_COPIES, 5, 24, 220, 26
+        GROUPBOX        "Number of copies", GB_COPIES, 5, 24, 220, 26, NOT 
+                        WS_VISIBLE
                         PRESPARAMS PP_FOREGROUNDCOLOR, 0x00000000L
                         PRESPARAMS PP_FONTNAMESIZE, "9.WarpSans Bold"
         LTEXT           "Spool this job", DT_COPIES, 13, 30, 54, 8, 
-                        DT_VCENTER
+                        DT_VCENTER | NOT WS_VISIBLE
         LTEXT           "times to the server", DT_COPIES2, 104, 30, 83, 8, 
-                        DT_VCENTER
-        ENTRYFIELD      "", ID_COPIES, 71, 31, 23, 8, ES_MARGIN
+                        DT_VCENTER | NOT WS_VISIBLE
+        ENTRYFIELD      "", ID_COPIES, 71, 31, 23, 8, ES_MARGIN | NOT 
+                        WS_VISIBLE
     END
 END
Index: /branches/1.0/src/makefile.kmk
===================================================================
--- /branches/1.0/src/makefile.kmk	(revision 10)
+++ /branches/1.0/src/makefile.kmk	(revision 11)
@@ -41,5 +41,5 @@
 
 uni_CFLAGS = -Zomf
-uni_CFLAGS.release = -s -O3 -march=pentium -mcpu=pentium4
+uni_CFLAGS.release = -s -O1 -march=pentium -mtune=pentium4
 uni_CFLAGS.debug = -g -O0 -DDEBUG
 uni_LDFLAGS = -Zomf -Zno-fork -Zmap -Zbin-files
@@ -138,10 +138,10 @@
 # final: zip all files!
 $(PATH_ROOT)/dist/$(PACKAGE_NAME): \
-		$(PATH_BIN)/en/uni.pdr
+		$(PATH_BIN)/uni.pdr
 	$(QUIET)$(MKDIR) -p $(PATH_ROOT)/dist                              
 	$(QUIET)$(RM) -f $@
 	-ea2.cmd -e DEFAULT_PORT=UNI $(PATH_BIN)/en/uni.pdr
 	-ea2.cmd -e DEFAULT_PORT=UNI $(PATH_BIN)/de/uni.pdr
-	$(QUIET)$(REDIRECT) -C $(PATH_BIN) -- zip -9 -r $@ *
+	zip -9 -r $@ $(PATH_BIN)/*
 
 
Index: /branches/1.0/src/uni.c
===================================================================
--- /branches/1.0/src/uni.c	(revision 10)
+++ /branches/1.0/src/uni.c	(revision 11)
@@ -179,5 +179,5 @@
 	{
 		case WM_INITDLG:
-			WinSendDlgItemMsg(hDlg,ID_BINARY,BM_SETCHECK,MPFROM2SHORT(1,0),NULL);
+//			WinSendDlgItemMsg(hDlg,ID_BINARY,BM_SETCHECK,MPFROM2SHORT(1,0),NULL);
 			pLprData = (PLPRDATA)mp2;
 			WinSetWindowULong (hDlg, QWL_USER, (ULONG)pLprData);
@@ -215,32 +215,9 @@
 					{
 						case 0:
-							WinSetDlgItemText(hDlg,ID_IP,token);
+							WinSetDlgItemText(hDlg,ID_PROGRAM,token);
 						case 1:
 							if (token[ strlen(token) - 1 ] == ';')
 								token[ strlen(token)-1 ] = '\0';
-							WinSetDlgItemText(hDlg,ID_UNIQUEUE,token);
-							break;
-						case 2:
-							if (token[ strlen(token) - 1 ] == ';')
-								token[ strlen(token)-1 ] = '\0';
-							WinSetDlgItemText(hDlg,ID_WORKGROUP,token);
-							break;
-						case 3:
-							if (token[ strlen(token) - 1 ] == ';')
-								token[ strlen(token)-1 ] = '\0';
-							WinSetDlgItemText(hDlg,ID_USER,token);
-							break;
-						case 4:
-							if (token[ strlen(token) - 1 ] == ';')
-								token[ strlen(token)-1 ] = '\0';
-							WinSetDlgItemText(hDlg,ID_COPIES,token);
-							break;
-
-						case 5:
-							if (token[ strlen(token) - 1 ] == ';')
-								token[ strlen(token)-1 ] = '\0';
-							strcpy(pwBuffer,token);
-							decryptPassword(pwBuffer,token);
-							WinSetDlgItemText(hDlg,ID_PASSWORD,token);
+							WinSetDlgItemText(hDlg,ID_PARAMETERS,token);
 							break;
 					}
@@ -257,18 +234,6 @@
 				case DID_OK:
 					sprintf(szDesc,"\\");
-					/* Servername | IP */
-					WinQueryDlgItemText (hDlg, ID_IP, sizeof(szTemp), szTemp );
-					sprintf(pLprData->szSaveLprSetting,"%s",szTemp);
-					strncpy(szShareName, szTemp, STR_LEN_PORTDESC - 1);
-					/* Printername | Queue */
-					WinQueryDlgItemText (hDlg, ID_UNIQUEUE, sizeof(szTemp), szTemp );
-					strcat(pLprData->szSaveLprSetting,"#");
-					strcat(pLprData->szSaveLprSetting,szTemp);
-					if (strlen(szTemp) > 0) {
-						strncat(szShareName, "\\", STR_LEN_PORTDESC - 1);
-						strncat(szShareName, szTemp, STR_LEN_PORTDESC - 1);
-					}
-					/* Workgroup */
-					WinQueryDlgItemText (hDlg, ID_WORKGROUP, sizeof(szTemp), szTemp );
+					/* Program */
+					WinQueryDlgItemText (hDlg, ID_PROGRAM, sizeof(szTemp), szTemp );
 					strcat(pLprData->szSaveLprSetting,"#");
 					strcat(pLprData->szSaveLprSetting,szTemp);
@@ -279,19 +244,33 @@
 					strncat(szDesc, "\\", STR_LEN_PORTDESC - 1);
 					strncat(szDesc, szShareName, STR_LEN_PORTDESC - 1);
-					/* Username */
-					WinQueryDlgItemText (hDlg, ID_USER, sizeof(szTemp), szTemp );
+					
+					/* Parameters */
+					WinQueryDlgItemText (hDlg, ID_PARAMETERS, sizeof(szTemp), szTemp );
+					sprintf(pLprData->szSaveLprSetting,"%s",szTemp);
+					strncpy(szShareName, szTemp, STR_LEN_PORTDESC - 1);
+					
+					/* Printername | Queue */
+/*					WinQueryDlgItemText (hDlg, ID_UNIQUEUE, sizeof(szTemp), szTemp );
 					strcat(pLprData->szSaveLprSetting,"#");
 					strcat(pLprData->szSaveLprSetting,szTemp);
+					if (strlen(szTemp) > 0) {
+						strncat(szShareName, "\\", STR_LEN_PORTDESC - 1);
+						strncat(szShareName, szTemp, STR_LEN_PORTDESC - 1);
+					} */
+					/* Username */
+/*					WinQueryDlgItemText (hDlg, ID_USER, sizeof(szTemp), szTemp );
+					strcat(pLprData->szSaveLprSetting,"#");
+					strcat(pLprData->szSaveLprSetting,szTemp); */
 					/* Number of copies */
-					WinQueryDlgItemText (hDlg, ID_COPIES, sizeof(szTemp), szTemp );
+/*					WinQueryDlgItemText (hDlg, ID_COPIES, sizeof(szTemp), szTemp );
 					strcat(pLprData->szSaveLprSetting,"#");
-					strcat(pLprData->szSaveLprSetting,szTemp);
+					strcat(pLprData->szSaveLprSetting,szTemp); */
 					/* Password - must be the last item! */
-					WinQueryDlgItemText (hDlg, ID_PASSWORD, sizeof(szTemp), szTemp );
+/*					WinQueryDlgItemText (hDlg, ID_PASSWORD, sizeof(szTemp), szTemp );
 					strcat(pLprData->szSaveLprSetting,"#");
 					strcpy(pwBuffer,szTemp);
 					encryptPassword(pwBuffer,szTemp);
 					strcat(pLprData->szSaveLprSetting,szTemp);
-
+ */
 					if (!PrfWriteProfileString (HINI_SYSTEMPROFILE,
 												pLprData->pszAppName,
@@ -975,7 +954,7 @@
 	UCHAR       binfile[256];
 	UCHAR       arg[256];
-	UCHAR       j_url[256] ;
+	UCHAR       j_parms[256] ;
 	UCHAR       j_id[3];
-	UCHAR       j_user[256];
+	UCHAR       parameters[256];
 	UCHAR       j_title[256];
 	UCHAR       j_copies[3];
@@ -1027,9 +1006,9 @@
 			switch(j)
 			{
-				case 0:strcpy(ip_add,&szTemp[pos]);
+				case 0:strcpy(binfile,&szTemp[pos]);
 						break;
-				case 1:strcpy(queue_name,&szTemp[pos]);
+				case 1:strcpy(parameters,&szTemp[pos]);
 						break;
-				case 2:strcpy(workgroup,&szTemp[pos]);
+/*				case 2:strcpy(workgroup,&szTemp[pos]);
 						break;
 				case 3:strcpy(username,&szTemp[pos]);
@@ -1038,5 +1017,5 @@
 						break;
 				case 5:strcpy(password_enc,&szTemp[pos]);
-						break;
+						break; */
 			}
 			pos = i+1;
@@ -1057,11 +1036,6 @@
 // Usage: smbspool [DEVICE_URI] job-id user title copies options [file]
 
-	sprintf(binfile, "smbspool.exe\0");
-	sprintf(j_url,"smb://%s:%s@%s/%s/%s",username,password_dec,workgroup,ip_add,queue_name);
-	sprintf(j_id,"999");
-	sprintf(j_user,username);
-	sprintf(j_title,"from %s",getenv("HOSTNAME"));
-	sprintf(j_options,"opt");
-	rc = spawnlp(P_WAIT,binfile,binfile,j_url,j_id,j_user,j_title,j_copies,j_options,filename,NULL);
+	sprintf(j_parms,parameters);
+	rc = spawnlp(P_WAIT,binfile,binfile,j_parms,filename,NULL);
 
 	while (rc != 0)
@@ -1075,5 +1049,5 @@
 		if (resp != MBID_CANCEL )
 		{
-			rc = spawnlp(P_WAIT,binfile,binfile,j_url,j_id,j_user,j_title,j_copies,j_options,filename,NULL);
+			rc = spawnlp(P_WAIT,binfile,binfile,j_parms,filename,NULL);
 		}
 		else rc = 0;
Index: /branches/1.0/src/uni.h
===================================================================
--- /branches/1.0/src/uni.h	(revision 10)
+++ /branches/1.0/src/uni.h	(revision 11)
@@ -184,19 +184,20 @@
    ULONG    lfModified;
 } LPRDATA, *PLPRDATA;
-#define ID_IP                       201
-#define ID_UNIQUEUE                 202
-#define ID_BINARY                   203
-/* #define ID_SPOOL_PATH            204 */
-#define DT_UNIQUEUE                 204
-#define DT_IP                       205
-#define GB_UNICFG                   206
-#define DT_WORKGROUP                207
-#define ID_WORKGROUP                208
-#define DT_USER                     209
-#define ID_USER                     210
-#define DT_PASSWORD                 211
-#define ID_PASSWORD                 212
-#define GB_COPIES                   213
-#define ID_COPIES                   214
-#define DT_COPIES                   215
-#define DT_COPIES2                  216
+#define ID_PROGRAM                  201
+#define DT_PROGRAM                  202
+#define ID_PARAMETERS               203
+#define DT_PARAMETERS               204
+#define GB_UNICFG                   205
+#define DT_UNIQUEUE                 206
+#define ID_UNIQUEUE                 207
+#define ID_BINARY                   208
+#define GB_COPIES                   209
+#define DT_COPIES                   210
+#define ID_COPIES                   211
+#define DT_COPIES2                  212
+
+/* #define ID_SPOOL_PATH               204 */
+/* #define DT_USER                     209 */
+/* #define ID_USER                     210 */
+/* #define DT_PASSWORD                 211 */
+/* #define ID_PASSWORD                 212 */