Index: trunk/openjdk/jdk/make/common/Defs.gmk
===================================================================
--- trunk/openjdk/jdk/make/common/Defs.gmk	(revision 14)
+++ trunk/openjdk/jdk/make/common/Defs.gmk	(revision 15)
@@ -135,16 +135,16 @@
 #   ALT_BINARY_PLUGS_JARFILE is probably rarely needed. It can be used
 #   to identify the exact jar file to be used for all closed classes..
-#  
+#
 #   ALT_BINARY_PLUGS_PATH points to a directory containing precisely the
-#   binaries needed to build. 
-#  
-#   ALT_BUILD_BINARY_PLUGS_PATH points to a directory containing binary plug dirs 
+#   binaries needed to build.
+#
+#   ALT_BUILD_BINARY_PLUGS_PATH points to a directory containing binary plug dirs
 #   multiple architectures named using the standard conventions
 #   This is useful for build scripts that need to build multiple architectures
 #   of the OpenJDK.
-#   
+#
 #   ALT_CLOSED_JDK_IMPORT_PATH points to the top-level of a specific platform
 #   JDK image.
-#  
+#
 #   The precedence is that
 #     1. ALT_BINARY_PLUGS_JARFILE overrides any other location of the classes
@@ -210,5 +210,5 @@
 endif
 ifeq ($(PLATFORM), solaris)
-  # historically for Solaris we have slightly different devtools 
+  # historically for Solaris we have slightly different devtools
   # naming conventions
   DEVTOOLS_FT_DIR=$(JDK_DEVTOOLS_DIR)/$(ARCH_FAMILY)/freetype-$(ARCH)
@@ -231,7 +231,7 @@
       USING_SYSTEM_FT_LIB=true
     endif
-  endif 
-
-  ifeq ($(PLATFORM), windows)
+  endif
+
+  ifeq ($(filter-out windows os2,$(PLATFORM)),)
     FREETYPE_LIB = $(FREETYPE_LIB_PATH)/freetype.lib
   else
@@ -336,6 +336,6 @@
 DOCSDIRSUFFIX       =
 
-# The MESSAGE, WARNING and ERROR files are used to store sanityck and 
-# SCCS check messages, warnings and errors. 
+# The MESSAGE, WARNING and ERROR files are used to store sanityck and
+# SCCS check messages, warnings and errors.
 ifndef ERROR_FILE
   ERROR_FILE   = $(OUTPUTDIR)/sanityCheckErrors.txt
@@ -356,8 +356,8 @@
 # An attempt is made to generate unique enough directories for the
 # generated files to not have name collisisons. Most build units
-# defines PRODUCT (except Release.gmk), but then they may or may 
-# not define PACKAGE, THREADIR (only HPI uses this), PROGRAM, and 
-# LIBRARY. This code chunk attempts to generate a unique 
-# OBJDIR/CLASSHDRDIR for each build unit based on which of those 
+# defines PRODUCT (except Release.gmk), but then they may or may
+# not define PACKAGE, THREADIR (only HPI uses this), PROGRAM, and
+# LIBRARY. This code chunk attempts to generate a unique
+# OBJDIR/CLASSHDRDIR for each build unit based on which of those
 # values are set within each build unit.
 
@@ -388,5 +388,5 @@
 endif
 
-# the use of += above makes a space separated list which we need to 
+# the use of += above makes a space separated list which we need to
 # remove for filespecs.
 #
@@ -406,5 +406,5 @@
 
 # OBJDIRNAME is the name of the directory where the object code is to
-#   be placed. It's name depends on whether the data model architecture 
+#   be placed. It's name depends on whether the data model architecture
 #   is 32-bit or not.
 ifneq ($(ARCH_DATA_MODEL), 32)
@@ -461,5 +461,5 @@
 
 #
-# VPATH.h is used elsewhere to generate include flags.  By default, 
+# VPATH.h is used elsewhere to generate include flags.  By default,
 # anyone has access to the include files that the JVM area exports,
 # namely jni.h, jvm.h, and jni_utils.h, plus their platform-specific
@@ -674,11 +674,11 @@
 VERSION_DEFINES = -DRELEASE='"$(RELEASE)"'
 
-# Note: As a rule, GNU Make rules should not appear in any of the 
+# Note: As a rule, GNU Make rules should not appear in any of the
 # Defs*.gmk files. These were added for Kestrel-Solaris and do address
 # a TeamWare bug. They should be moved elsewhere for Merlin.
-# 
+#
 #  Override gnumake built-in rules which do sccs get operations badly.
 #  (They put the checked out code in the current directory, not in the
-#  directory of the original file.) 
+#  directory of the original file.)
 # Since this is a symptom of a teamware failure, complain and die on the spot.
 
Index: trunk/openjdk/jdk/make/tools/freetypecheck/Makefile
===================================================================
--- trunk/openjdk/jdk/make/tools/freetypecheck/Makefile	(revision 14)
+++ trunk/openjdk/jdk/make/tools/freetypecheck/Makefile	(revision 15)
@@ -54,4 +54,8 @@
   DFLAG=/D
 else
+ifeq ($(PLATFORM), os2)
+  FT_OPTIONS += $(LDFLAGS)
+  DFLAG = -D
+else
   FT_OPTIONS += -L$(FT_LIB)
   DFLAG = -D
@@ -63,4 +67,5 @@
       FT_OPTIONS += -Wl,-rpath -Wl,$(FT_LIB)
   endif
+endif
 endif
 