Index: /branches/v2.9/classes/help/en/cwmm.ipf
===================================================================
--- /branches/v2.9/classes/help/en/cwmm.ipf	(revision 18)
+++ /branches/v2.9/classes/help/en/cwmm.ipf	(revision 19)
@@ -251,5 +251,5 @@
 :p.Specify the target audio file type and filename, including the full path.
 Source audio file details are displayed at the top of the dialog. Note that some
-fomats may be more lossy than others, and converting from a lossy format to a
+formats may be more lossy than others, and converting from a lossy format to a
 less-lossy (or lossless) format will not restore original bits which may no
 longer be present in the (lossy) source file, and in some cases, may result in
@@ -262,3 +262,45 @@
 exit the dialog.
 
+
+.* ----------------------------------------------------------------------------
+:h1 res=200.Image details
+:p.This page displays various technical details about the selected image.
+
+:p.The following read-only information is provided&colon.
+
+:hp2.
+:table rules=both frame=box cols='20 40'.
+:row.
+:c.Detail
+:c.Description
+:row.
+:c.IOProc
+:c.Identifies which MMIOProc is being used to render the image.
+:row.
+:c.Width
+:c.Width in pixels of the image.
+:row.
+:c.Height
+:c.Height in pixels of the image.
+:row.
+:c.Depth
+:c.Number of colors (color depth) of the image.
+:etable.
+:ehp2.
+
+.* ----------------------------------------------------------------------------
+:h1 res=210.Convert digital image
+:p.Specify the target image file type and filename, including the full path.
+A thumbnail of the source image file is displayed at the top of the dialog. Note
+that some formats may be more lossy than others, and converting from a lossy
+format to a less-lossy (or lossless) format will not restore original bits which
+may no longer be present in the (lossy) source file, and in some cases, may
+result in a converted file of lower quality than the lossy source.
+
+:p.The dropdown will list available MMIOProcs (codecs) for the target file.
+
+:p.Press the :hp2.Convert:2hp2. button to begin the process, and
+:hp2.Abort:ehp2. to cancel once conversion has begun. Press :hp2.Close:ehp2. to
+exit the dialog.
+
 :euserdoc.
Index: /branches/v2.9/classes/res/en/audioconv_en.dlg
===================================================================
--- /branches/v2.9/classes/res/en/audioconv_en.dlg	(revision 18)
+++ /branches/v2.9/classes/res/en/audioconv_en.dlg	(revision 19)
@@ -8,16 +8,16 @@
             FCF_SYSMENU | FCF_TITLEBAR
     BEGIN
-        GROUPBOX        "", IDGB_CONVERT, 3, 105, 203, 69
+        GROUPBOX        "Source", IDGB_CONVERT, 3, 105, 203, 69
         LTEXT           "Name:", IDST_CONVERTNAMELABEL, 7, 156, 32, 8
         RTEXT           "", IDST_CONVERTNAME, 45, 156, 156, 8
-        LTEXT           "? Hz", IDST_CONVERTSAMPLERATE, 7, 131, 91, 8
-        LTEXT           "? Channels", IDST_CONVERTCHANNELS, 7, 120, 91, 8
-        LTEXT           "", IDST_CONVERTCDBITS, 103, 142, 98, 8
+        LTEXT           "Sample rate: ? Hz", IDST_CONVERTSAMPLERATE, 7, 131, 91, 8
+        LTEXT           "Channels: ?", IDST_CONVERTCHANNELS, 7, 120, 91, 8
+        LTEXT           "Bits per sample: ?", IDST_CONVERTCDBITS, 103, 142, 98, 8
         LTEXT           "(CD: 44100 Hz)", IDST_CONVERTCDSAMPLELABEL, 103, 131, 
                         98, 8
         LTEXT           "(CD: 2 Channels)", IDST_CONVERTCDCHANNELSLABEL, 103, 
                         120, 98, 8
-        LTEXT           "Playtime: ?", IDST_CONVERTPLAYTIME, 7, 109, 161, 8
-        GROUPBOX        "", IDGB_CONVERT2, 3, 19, 203, 85
+        LTEXT           "Play time: ?", IDST_CONVERTPLAYTIME, 7, 109, 161, 8
+        GROUPBOX        "Target", IDGB_CONVERT2, 3, 19, 203, 85
         LTEXT           "Convert to:", 317, 7, 86, 86, 8
         CONTROL         "", IDDD_IOPROC, 7, 28, 195, 54, WC_COMBOBOX, 
@@ -26,6 +26,6 @@
 
         LTEXT           "Target name:", 2419, 7, 57, 64, 8
-        ENTRYFIELD      "", IDEF_CONVERTTARGETNAME, 9, 45, 139, 8, ES_RIGHT | 
-                        ES_MARGIN
+        ENTRYFIELD      "", IDEF_CONVERTTARGETNAME, 9, 45, 139, 8, ES_MARGIN
+
         PUSHBUTTON      "~Browse...", IDPB_CONVERTBROWSE, 153, 42, 47, 14
         CONTROL         "", IDBAR_CONVERTPROGRESS, 6, 24, 194, 13, 
@@ -36,3 +36,2 @@
     END
 END
-
Index: /branches/v2.9/classes/res/en/audioconv_en.rc
===================================================================
--- /branches/v2.9/classes/res/en/audioconv_en.rc	(revision 18)
+++ /branches/v2.9/classes/res/en/audioconv_en.rc	(revision 19)
@@ -7,7 +7,7 @@
 BEGIN
 
-IDSTR_CONVERTCHANNELS    "%d Channels"
-IDSTR_CONVERTSAMPLERATE  "%d Hz"
-IDSTR_CONVERTPLAYTIME    "%d:%02d min playtime"
+IDSTR_CONVERTCHANNELS    "Channels: %d"
+IDSTR_CONVERTSAMPLERATE  "Sample rate: %d Hz"
+IDSTR_CONVERTPLAYTIME    "Play time: %d:%02d"
 IDSTR_CONVERTDIALOGERROR "Can't load dialog template! Please check your installation."
 IDSTR_CONVERTNOSPACETITLE   "Convert to wave"
@@ -17,4 +17,2 @@
 
 END
-
-
Index: /branches/v2.9/classes/res/en/cwaudio_en.dlg
===================================================================
--- /branches/v2.9/classes/res/en/cwaudio_en.dlg	(revision 18)
+++ /branches/v2.9/classes/res/en/cwaudio_en.dlg	(revision 19)
@@ -11,5 +11,5 @@
         PUSHBUTTON      "~Cancel", IDPB_CANCEL, 87, 1, 40, 14
         PUSHBUTTON      "~Help", IDPB_ID3HELP, 130, 1, 40, 14, BS_HELP
-        GROUPBOX        "ID3 Tags", IDGB_ID3TAGS, 6, 17, 202, 97
+        GROUPBOX        "", IDGB_ID3TAGS, 6, 17, 202, 97
         LTEXT           "Name:", 210, 9, 95, 57, 8
         ENTRYFIELD      "", IDEF_ID3NAME, 73, 95, 127, 8, ES_MARGIN
@@ -33,7 +33,7 @@
             WS_VISIBLE | NOT WS_SAVEBITS
     BEGIN
-        GROUPBOX        "Audio info", IDGB_WAVEINFO, 6, 4, 154, 67, NOT 
+        GROUPBOX        "", IDGB_WAVEINFO, 6, 4, 154, 67, NOT 
                         WS_GROUP
-        LTEXT           "Samplerate:", IDST_SAMPLERATELABEL, 17, 35, 76, 8
+        LTEXT           "Sample rate:", IDST_SAMPLERATELABEL, 17, 35, 76, 8
         LTEXT           "Bits per sample:", IDST_BPSLABEL, 17, 23, 76, 8
         LTEXT           "Play time:", IDST_PLAYTIMELABEL, 17, 47, 76, 8
@@ -51,5 +51,5 @@
             WS_VISIBLE
     BEGIN
-        GROUPBOX        "Image Information", IDGB_IMAGEINFO, 6, 4, 154, 78, 
+        GROUPBOX        "", IDGB_IMAGEINFO, 6, 4, 154, 78, 
                         NOT WS_GROUP
         LTEXT           "Width:", IDST_IMAGEWIDTHLABEL, 17, 35, 76, 8
@@ -71,7 +71,6 @@
         GROUPBOX        "URL", IDGB_STREAMURL, 6, 4, 154, 61, NOT WS_GROUP
         ENTRYFIELD      "", IDEF_URL, 13, 23, 140, 8, ES_MARGIN
-        LTEXT           "Enter URL to streaming server:", IDST_URLTEXT, 12, 
+        LTEXT           "Enter URL for streaming server:", IDST_URLTEXT, 12, 
                         37, 143, 8
     END
 END
-
Index: /branches/v2.9/classes/res/en/cwaudio_en.rc
===================================================================
--- /branches/v2.9/classes/res/en/cwaudio_en.rc	(revision 18)
+++ /branches/v2.9/classes/res/en/cwaudio_en.rc	(revision 19)
@@ -31,5 +31,5 @@
 MENU ID_MENU_EDITOR
 BEGIN
-        MENUITEM "~Audioeditor", ID_MENU_EDITOR       
+        MENUITEM "~Audio editor", ID_MENU_EDITOR       
 END
 
@@ -71,11 +71,11 @@
 STRINGTABLE 
 BEGIN
-ID_WAVEINFOPAGENAME "~Audio information"
-ID_ID3TAGSPAGENAME  "~ID3 Tags"
-ID_TRACKNAMEPAGENAME "~Track name"
-IDSTR_TRACKNAME      "Trackname"
+ID_WAVEINFOPAGENAME "~Audio details"
+ID_ID3TAGSPAGENAME  "~ID3 tag"
+ID_TRACKNAMEPAGENAME "~Track meta"
+IDSTR_TRACKNAME      ""
 
 IDSTR_PLAYTIME      "Play time"
-IDSTR_SAMPLERATE    "Samplerate"
+IDSTR_SAMPLERATE    "Sample rate"
 IDSTR_CHANNELS      "Channels"
 IDSTR_BPS           "Bits per sample"
@@ -113,8 +113,8 @@
 ;Used as an information when starting and audio file from the WPS
 IDSTR_STARTINGTRACK      "Starting track..."
-IDSTR_AUDIOSCANNING     "Scanning Audiofile..."
-IDSTR_AUDIOSTREAMTITLE  "Audio-Stream"
-IDSTR_STREAMURLPAGENAME "~URL-Setting"
-IDSTR_CDTRACKTITLE      "CD-Track"
+IDSTR_AUDIOSCANNING     "Scanning audio file..."
+IDSTR_AUDIOSTREAMTITLE  "Audio stream"
+IDSTR_STREAMURLPAGENAME "~URL"
+IDSTR_CDTRACKTITLE      "CD track"
 IDSTR_M3UTITLE          "M3U playlist"
 ;Titles used when starting player and editor applications
@@ -127,4 +127,2 @@
 
 END
-
-
Index: /branches/v2.9/classes/res/en/cwimage_en.rc
===================================================================
--- /branches/v2.9/classes/res/en/cwimage_en.rc	(revision 18)
+++ /branches/v2.9/classes/res/en/cwimage_en.rc	(revision 19)
@@ -26,6 +26,6 @@
 IDSTR_CWIMAGETITLE  "Digital image"
 
-IDSTR_IMAGEINFOPAGENAME "~Image information"
-IDSTR_SPRINTFPIXEL	"%d Pixel"
+IDSTR_IMAGEINFOPAGENAME "~Image details"
+IDSTR_SPRINTFPIXEL	"%d Pixels"
 IDSTR_SPRINTFBIT       "%d Bit"
 ;Bitmpap load errors
@@ -42,9 +42,7 @@
 
 ;Titles used when starting player and editor applications
-IDSTR_IMGEDITORTITLE       "Imageviewer"
+IDSTR_IMGEDITORTITLE       "Image viewer"
 IDSTR_MENU_IMAGEINFO        "Image information: %d x %d x %d"
 
 ;IDSTR_HELPLIBRARY   "MMPARTS.HLP"
 END
-
-
Index: /branches/v2.9/classes/res/en/imageconv_en.dlg
===================================================================
--- /branches/v2.9/classes/res/en/imageconv_en.dlg	(revision 18)
+++ /branches/v2.9/classes/res/en/imageconv_en.dlg	(revision 19)
@@ -13,5 +13,5 @@
         CONTROL         "", IDSR_BMP, 12, 100, 185, 69, WC_STATIC, 
                         SS_FGNDRECT | WS_GROUP | WS_VISIBLE
-        LTEXT           "Convert to", IDST_IMGCONVERTTO, 7, 88, 53, 8
+        LTEXT           "Convert to:", IDST_IMGCONVERTTO, 7, 88, 53, 8
         CONTROL         "", IDDD_IMGIOPROC, 6, 6, 196, 78, WC_COMBOBOX, 
                         CBS_DROPDOWNLIST | LS_HORZSCROLL | WS_GROUP | 
@@ -27,3 +27,2 @@
     END
 END
-
Index: /branches/v2.9/classes/res/en/mmfind_en.rc
===================================================================
--- /branches/v2.9/classes/res/en/mmfind_en.rc	(revision 18)
+++ /branches/v2.9/classes/res/en/mmfind_en.rc	(revision 19)
@@ -10,4 +10,4 @@
 IDSTR_AUDIOINFOTEXT   "Play time:\t%02d:%02d\n\nSamplerate:\t%d\n\nBits per sample:\t%d\n\nChannels:\t%d"
 IDSTR_NOMMTEMPLATEFLDRTITLE "Error during file creation"
-IDSTR_NOMMTEMPLATEFLDR "Multimedia template folder can't be found. It may has lost the object ID <MMPM2_MMTEMPLATEFOLDER>."
+IDSTR_NOMMTEMPLATEFLDR "Multimedia template folder can't be found. It may have lost the object ID <MMPM2_MMTEMPLATEFOLDER>."
 END