Index: psi/trunk/INSTALL
===================================================================
--- psi/trunk/INSTALL	(revision 20)
+++ psi/trunk/INSTALL	(revision 21)
@@ -17,4 +17,9 @@
   run the Psi executable.  You might want to move everything into
   C:\Program Files\Psi
+
+-=[ eComStation / OS/2 ]=-
+
+  For automatic installation, just use the provided WarpIn archive.
+  For manual installation instructions, refer to the Readme-OS2.txt file.
 
 -=[ MacOS X ]=-
Index: psi/trunk/Readme-OS2.txt
===================================================================
--- psi/trunk/Readme-OS2.txt	(revision 21)
+++ psi/trunk/Readme-OS2.txt	(revision 21)
@@ -0,0 +1,166 @@
+Psi 0.10-os2-b1 (Beta 1)
+------------------------
+Date: August 18th, 2006
+
+
+OS/2 Port Creator/Maintainer:
+    Dmitry A. Kuminov
+    dmik-qt(at)hugaida.com
+    http://svn.netlabs.org/qt3/ticket/25
+
+Using Qt Toolkit Version 3 for OS/2:
+    Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
+    Copyright (C) 2004 Norman ASA.  Initial OS/2 Port.
+    Copyright (C) 2005-2006 netlabs.org.  Further OS/2 Development.
+    Ported to OS/2 by Dmitry A. Kuminov
+    http://svn.netlabs.org/qt3
+
+
+This readme contains information specific to the OS/2 version of Psi.
+For general information, please refer to Readme.txt, Install.txt and
+to the online documentation you can find at http://psi-im.org/.
+
+For the list of changes, see the bottom of this file. 
+
+
+Manual Installation
+-------------------
+
+1.  Make sure Innotek (Bird) LIBC 0.6.1 library (libc061.dll) is
+    installed on your system. Download the library from
+    ftp://ftp.netlabs.org/pub/gcc/libc-0.6.1-csd1.zip and unzip
+    the archive to the directory you plan to install Psi to or to
+    one of the directories listed in your LIBPATH environment variable.
+
+2.  Unzip the Psi archive containing this file to the directory of your
+    choice and run the Psi executable (psi.exe). No additional
+    installation is required.
+
+
+Configuration data
+------------------
+
+Psi stores all configuration files in the subdirectory /PsiData of
+your home directory (pointed to by the HOME environment variable).
+
+The name of the last used Psi profile is stored in the registry
+under the key HKEY_CURRENT_USER\Software\Affinix\psi.
+
+
+Current Limitations and Known Bugs
+----------------------------------
+
+1.  Using the PM Default Browser/Mail choice for opening links doesn't
+    work yet. The Custom browser setting requires a command like
+    'cmd /c cd D:\Apps\Firefox & D:\Apps\Firefox\Firefox.exe'.
+    
+2.  SSL connection is completely untested and will most likely not work.
+
+3.  PGP encryption is completely untested and probably will not work.
+
+4.  The global hot keys are not available. 
+ 
+5.  Idle (i.e. Auto-Away) detection may not work properly.
+
+6.  The directory watcher service is not available (though I don't yet know
+    what is it good for in Psi). 
+
+7.  There is no "tray icon" (xCenter widget) for Psi. It will be available
+    later.
+    
+8.  Power management events such as "sleep" or "wakeup" are not detected by Psi.
+
+9.  Drag and Drop support in Qt/OS2 is not yet finished, so there are few
+    known issues (for example, text in entry fields may be corrupted when the
+    drag object is moved over them).
+
+10. The "Roaster window always on top" option is temporarily removed from the
+    options dialog because this functionality is not yet available in Qt/OS2.
+
+
+Bug Reports
+-----------
+
+To submit a bug report, please visit http://svn.netlabs.org/qt3/ticket/25
+and add a comment describing the problem.
+
+Note that in order to add a comment, you'll need to login to the Trac system
+using the special name and the password presented on the start page
+(http://svn.netlabs.org/qt3/wiki).  
+
+
+Contributors
+------------
+
+Thanks to the following people who contributed to Psi/2:
+
+Ivan Smirnoff
+    www.sampo.ru/~bigvic 
+	OS/2 icon
+
+Juergen Ulbts
+    WarpIn scripts
+
+
+Changes
+-------
+
+Note: fixes marked as [Qt ...] are applied to the Qt library for OS/2,
+not to Psi itself.
+
+*   Version 0.10-os2-b1 (2006-08-18)
+    --------------------------------
+
+    - Built using Qt 3.3.1-RC7 SVN build r118.
+
+    - New: Chat tabs can be switched using Ctrl+Tab and Ctrl+Shift+Tab
+      combinations (together with cross-platform Ctrl+PgUp/Ctrl+PgDn).
+
+    - New: Pressing the Esc key in the Roster window minimizes it
+      if the Doclet widget (tray icon) is disabled (which is always true
+      on OS/2 since there is no xCenter/SysTray integration yet).
+
+    - Fixed: Removed the Options->Sound->Player entry field (not used in
+      OS/2).
+
+    - Fixed: Unpainted vertical strip in QToolBar (seen to the left from the
+      Clear chat window button) [Qt bug].
+
+    - Fixed: Pressing AltGr+key could produce valid characters in some
+      keyboard layouts (i.e. the German one) which were ignored in the chat
+      window [Qt bug].
+
+    - Fixed: In the roster: pressing the Status button right after pressing
+      the Psi button didn't unpress the latter (and vice versa) [Qt bug].
+
+    - Fixed: Notification popups didn't take the desktop work area size into
+      account (appeared over the xCenter widget) [Qt enhancement].
+
+    - Fixed: Playing too many sounds simultaneously could screw up a
+      single-streamed audio driver and cause the application hang during
+      termination or even a crash [Qt improvement].
+
+    - Fixed: All network activity (including file transfer) was suspended
+      during moving or resizing Psi windows using the mouse [Qt improvement].
+
+    - Fixed: Selecting 'Rerequest authorization from' in the context menu
+      of ICQ and Transport contacts in the Roster would crash Psi.
+
+    - Fixed: Opening the chat window could sometimes crash Psi (SIGFPE)
+      [Qt bug].
+
+    - Fixed: When both "Open chats in tabbed mode" and "Raise chat window on
+      receiving new messages" were set, receiving a new message would bring
+      the chat window to front but would not change the active tab to the one
+      corresponding to the chat window.
+
+    - Fixed: Closing Psi trying to connect (resolve the server name) when
+      there was no Internet connection hid all Psi windows but didn't exit
+      the process until the request timed out (that could take quite a
+      long and didn't allow to start another Psi instance).
+
+
+*   Version 0.10-os2-a1 (2006-07-25)
+    --------------------------------
+    
+    The first public alpha version.