Index: trunk/os2-doc/macros.html
===================================================================
--- trunk/os2-doc/macros.html	(revision 23)
+++ 	(revision )
@@ -1,320 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<?xml-stylesheet type="text/css"
-href="file:qtos2-xxe.css"
-?>
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
-"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
-<html>
-  <head>
-    <link href="qtos2-www.css" rel="stylesheet" type="text/css" />
-
-    <link href="#top" rel="top" />
-
-    <link href="index.html" rel="first" />
-
-    <link href="changes.html" rel="prev" />
-
-    <title>Qt for OS/2 Project</title>
-  </head>
-
-  <body id="changelog">
-    <h1><a name="top">The meaning of some macros</a></h1>
-
-    <p>This table contains descriptions of some (mostly internal) macros which
-    are not described anywhere (or not enough described) in the original Qt
-    docs. It does not pretend to be a complete list of all Qt macros -- only
-    those that are considered to be interesting or important are mentioned
-    here.</p>
-
-    <table border="1">
-      <thead>
-        <tr>
-          <th>Macro</th>
-
-          <th>Meaning</th>
-
-          <th>Scope</th>
-
-          <th>Notes</th>
-        </tr>
-      </thead>
-
-      <tr>
-        <td><code>Q_OS_OS2</code></td>
-
-        <td>We're compiling under OS/2</td>
-
-        <td>everywhere</td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>Q_OS_OS2EMX</code></td>
-
-        <td>We're compiling under OS/2in EMX mode to be run under
-        XFree86/2</td>
-
-        <td>everywhere</td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>Q_WS_PM</code></td>
-
-        <td>We're compiling for the OS/2 PM windowing system</td>
-
-        <td>everywhere</td>
-
-        <td>This macro is defined if <code>Q_OS_OS2</code> is defined, and
-        <b>not</b> if <code>Q_OS_OS2EMX</code> is</td>
-      </tr>
-
-      <tr>
-        <td><code>HAVE_QCONFIG_CPP</code></td>
-
-        <td>If defined it means that the <kbd>tools</kbd> package contains
-        <code>gconfig.cpp</code>, that contains static <code>char*</code>
-        constants for various Qt installation paths
-        (<code>QT_INSTALL_*</code>). Otherwise it is assumed that these
-        constants are <code>#define</code>d somewhere in makefiles during
-        compilation.</td>
-
-        <td><kbd>qmake</kbd> only</td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>Q_FS_FAT</code></td>
-
-        <td>The filesystem Qt lives in is FAT-like (i.e. <code>;</code> are
-        used as path separators instead of <code>:</code> and so on).</td>
-
-        <td><code>QDir</code> class</td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>QT_LARGEFILE_SUPPORT</code></td>
-
-        <td>OS supports manipulations with large (&gt;2/4G) files</td>
-
-        <td></td>
-
-        <td>In OS/2 we currently disable it since only JFS has a support of
-        large files.</td>
-      </tr>
-
-      <tr>
-        <td><code>NEEDS_QMAIN</code></td>
-
-        <td>If defined, then the symbol <code>main</code> is redefined as
-        <code>qMain</code></td>
-
-        <td></td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>QWS</code></td>
-
-        <td>Qt/Embedded ??</td>
-
-        <td></td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>QT_NO_COMPONENT</code></td>
-
-        <td>If defined, no dynamic module linking (runtime DLL loading) (?)
-        will be done</td>
-
-        <td>some classes</td>
-
-        <td>On Windows, this disables (?) COM support and
-        <code>QPluginManager</code>. Also, If this is <b>not</b> defined, then
-        <code>QFileInfo</code> will use dynamic loading of
-        <kbd>ADVAPI32.DLL</kbd> to resolve some security info functions.
-        Currently I don't know whether we should take this macro into account
-        under OS/2 or not.</td>
-      </tr>
-
-      <tr>
-        <td><code>QT_NO_TEXTCODEC</code></td>
-
-        <td>If defined, no <code>QTextCodec</code> class will be available and
-        all unicode strings will be considered as <kbd>latin1</kbd>
-        strings</td>
-
-        <td>in parts related to the text conversion</td>
-
-        <td>In particular, this means that any conversion from Unicode to
-        single byte strings will be done by simple casting of every unicode
-        char to a regular char (i.e. eliminating the high byte of the unicode
-        word) and replacing unicode symbols whose codes higher than
-        <code>0xFF</code> with the '<code>?</code>' char.</td>
-      </tr>
-
-      <tr>
-        <td><code>QT_NO_CODECS</code></td>
-
-        <td>If defined, there will be no Tamil, ISCII, Herbew and simple
-        codecs</td>
-
-        <td><kbd>codecs</kbd> module</td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>QT_NO_BIG_CODECS</code></td>
-
-        <td>Will be no big codecs such as Japanese etc.</td>
-
-        <td><kbd>codecs</kbd> module</td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>UNICODE</code></td>
-
-        <td>if defined, Win32 uses <code>*W</code> versions of API functions
-        when the unicode support is available, and <code>*A</code>
-        otherwise</td>
-
-        <td>win32-related parts of code (anywhere else?)</td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>QT_NO_COMPAT</code></td>
-
-        <td>If defined no obsolete class methods are implemented during Qt
-        compilation</td>
-
-        <td>somewhere</td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>QT_DLL</code></td>
-
-        <td>If defined it means that the application is being linked with the
-        DLL version of Qt</td>
-
-        <td><code>qglobal.h</code></td>
-
-        <td>only for Win32 at the present</td>
-      </tr>
-
-      <tr>
-        <td><code>QT_MAKEDLL</code></td>
-
-        <td>If defined it means that the DLL version of Qt is being
-        compiled</td>
-
-        <td><code>qglobal.h</code></td>
-
-        <td>only for Win32 at the present (linux version compiled under
-        Borland uses <code>QT_SHARED</code> define for these purposes)</td>
-      </tr>
-
-      <tr>
-        <td><code>Q_QDOC</code></td>
-
-        <td>Constructs that are visible when this macro is defined, are used
-        to generate the Qt reference documentation (i.e. real constructs used
-        when compiling Qt can differ)</td>
-
-        <td>elsewhere</td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>QT_NO_PIXMAP_TRANSFORMATION</code></td>
-
-        <td>When defined, no QPixmap::xForm() and trueMatrix() are
-        available</td>
-
-        <td><code>QPixmap</code> and <code>QBitmap</code> classes</td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>QT_NO_PRINTER</code></td>
-
-        <td>When defined, no <code>QPrinter</code> and <code>QPSPrinter</code>
-        classes are available</td>
-
-        <td><code>QPrinter</code>, <code>QPSPrinter</code> and
-        <code>QPainter</code> sources</td>
-
-        <td></td>
-      </tr>
-
-      <tr>
-        <td><code>QT_NO_LAYOUT</code></td>
-
-        <td>No <code>QLayout*</code>, <code>QWidgetItem</code>, and
-        <code>Q*Layout</code> classes, i.e. no layout management</td>
-
-        <td>sources of these classes</td>
-
-        <td></td>
-      </tr>
-    </table>
-
-    <h1>The meaning of some qmake CONFIG options</h1>
-
-    <p>The table below contains the meaning of some qmake CONFIG variable
-    options that are recognized by qmake and used in some project files.</p>
-
-    <table border="1">
-      <thead>
-        <tr>
-          <th>Option</th>
-
-          <th>Meaning</th>
-
-          <th>Scope</th>
-
-          <th>Notes</th>
-        </tr>
-      </thead>
-
-      <tr>
-        <td><code>shared</code></td>
-
-        <td>qmake assumes that the application is linked with the dll version
-        of Qt and automatically adds the <code>QT_DLL</code> define</td>
-
-        <td></td>
-
-        <td>Win32</td>
-      </tr>
-
-      <tr>
-        <td><code>staticlib</code></td>
-
-        <td>this is the opposite to <code>dll</code> (the latter takes
-        precedence), meaning that a static library (not DLL) is being
-        compiled</td>
-
-        <td></td>
-
-        <td>This meaning in Win32 only (?)</td>
-      </tr>
-    </table>
-  </body>
-</html>
Index: trunk/os2-doc/misc.html
===================================================================
--- trunk/os2-doc/misc.html	(revision 23)
+++ trunk/os2-doc/misc.html	(revision 26)
@@ -20,5 +20,5 @@
 
     <p>Dmitry A. Kuminov (<a
-    href="mailto:dmik.against-stupid-spammers@hugaida.com">dmik.against-stupid-spammers@hugaida.com</a>)
+    href="mailto:dmik-qt at hugaida.com">dmik-qt at hugaida.com</a>)
     -- porting the Qt Library to OS/2, project maintainance.</p>
 